#include "LDSUtils.h"
#include <cmath>
#define CARRE(A) ((A) * (A))

void NodePosition::setNode(int node){
	_node = node;
}
void NodePosition::setX(int x){
	_x = x;
}
void NodePosition::setY(int y){
	_y = y;
}
void NodePosition::setZ(int z){
	_z = z;
}
int NodePosition::getNode(){
	return _node;
}
int NodePosition::getX(){
	return _x;
}
int NodePosition::getY(){
	return _y;
}
int NodePosition::getZ(){
	return _z;
}

float distance2Node(NodePosition a,NodePosition b){
	float vx = b.getX() - a.getX();
	float vy = b.getY() - a.getY();
	float vz = b.getZ() - a.getZ();
	return sqrt(CARRE(vx) + CARRE(vy) + CARRE(vz));	
}

//calcule l'aire du triangle creer par ces 3 point
float HauteurTriangle3Node(NodePosition e,NodePosition r,NodePosition d){
	float ed = distance2Node(e,d);
	float er = distance2Node(e,r);
	if(ed == 0) return er;//e et d sont confondue
	
	float dr = distance2Node(d,r);
	float s = 0.5 *(ed + er + dr);
	float aire = sqrt(s * (s-ed) * (s-er) * (s-dr));
	float hauteur = 2 * aire / ed;
	return hauteur;
}
